/*
 * Class:       Karta.java
 *              Servlet pro hru Pexeso.
 * Datum:       20. 5. 2011
 * Autor:       jandora1
 */

package jandora1;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

public class Pexeso extends HttpServlet {

    public static final String SESSION_KEY = "pexeso";

    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */

    //obslouzi nacteni stranky
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        //objekt, relace, ktera si dokaze zapamatovat data pro daneho uzivatele
        //HTTP = bezestavovy protokol (pro dva uzivatele by musely byt dva)
        HttpSession ses = request.getSession();

        //session_key = pexeso
        Object o = ses.getAttribute(SESSION_KEY);

        //definice plochy
        Plocha p;

        //plocha = null - vytvori se nova plocha a ulozi se do session
        if (o == null) {
            p = new Plocha();
            ses.setAttribute(SESSION_KEY, p);

        //plocha = existuje - pretypuje se v session
        } else {
            p = (Plocha) o;
        }

        //plocha se ulozi, aby se dala pouzit na JSP strance
        request.setAttribute("plocha", p);
        try {
            otoc(p, request);   //pokud otacime otoc karty
            otocZpet(p, request);
        } catch (IllegalArgumentException ex) {
            ses.invalidate();
            response.sendRedirect(request.getRequestURL().toString());
            return;
        }

        //informace pro ladeni
        System.out.println("context path: " + request.getContextPath());
        System.out.println("url :" + request.getRequestURL());
        System.out.println("uri :" + request.getRequestURI());

        if (request.getParameter("zobraz") != null) {
            getServletContext().getRequestDispatcher("/Pexeso.jsp").forward(request, response);
        } else {
            response.sendRedirect(request.getRequestURL().toString() + "?zobraz=true");
        }
    }

    //vsechny karty otoci zpet
    public void otocZpet(Plocha p, HttpServletRequest request) {
        String str = request.getParameter("otoczpet");
        if (str != null) {
            p.otocZpet();
        }
    }

    //otaci kartu
    public void otoc(Plocha p, HttpServletRequest request) {
        String str = request.getParameter("otoc");
        if (str != null) {
            p.otoc(Integer.valueOf(str));
        }
    }

    
    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}